#ifndef MW_HTML_PARSER_H
#define MW_HTML_PARSER_H

typedef struct MwHtmlNode {
	char *tag;		/* tag name */
	char *text;		/* text */
	struct MwHtmlNode *parent;	/* parent */
	struct MwHtmlNode *next;	/* next sibling */
	struct MwHtmlNode *child;	/* first child */
} MwHtmlNode;

extern void MwHtmlDump(MwHtmlNode *h, int i);
extern char *MwHtmlGetValue(char *, char *);
extern void MwHtmlFree(MwHtmlNode *h);
extern MwHtmlNode *MwHtmlParse(int (*getc_cb)(void *), void *);

extern void MwHtmlDumpTree(MwHtmlNode *, void *,
		int (*)(void *, int, int),
		void (*)(void *, char *),
		void (*)(void *),
		void (*)(void *, char *));
extern int MwHtmlGetHref(char *, int);

#endif	/* MW_HTML_PARSER */
