
#include <stdio.h>
#include <string.h>
#include <sys/types.h>
#include <Mowitz/MwUtils.h>
#include "kylie.h"

/* mapping from extension to mime type */
static struct {
	char *ext, *type;
} mt[] = {
	{"txt", "text/plain"},
	{"html", "text/html"},
	{"shtml", "text/html"},
	{"jpg", "image/jpeg"},
	{"jpeg", "image/jpeg"},
	{"png", "image/png"},
	{"gif", "image/gif"},
	{NULL, NULL}};

static char *type(char *ext)
{
	int i;

	for (i = 0; mt[i].ext; i++) {
		if (!MwStrcasecmp(mt[i].ext, ext)) return mt[i].type;
	}
	return "text/html";
}

/* The url looks like file:///whatever */
int load_file(struct url_info *ui)
{
	char b[1024], *p, *t, *fn;
        int n;
	FILE *fp = NULL;
printf("load_file(url = '%s', nurl = '%s')\n", ui->url, ui->nurl);
	fn = strstr(ui->nurl, "://");
	if (fn) {
		fn += 3;
		fp = fopen(fn, "r");
	}
        if (fp == NULL) {
		MwFree(ui->nurl);
		ui->nurl = MwStrdup("about:error");
		return load_url(ui);
	}
	p = strrchr(fn, '.');
	if (p) t = type(p+1);
	else t = "text/html";
        fseek(fp, 0, SEEK_END);
        n = ftell(fp);
        fseek(fp, 0, SEEK_SET);
        ui->data = MwMalloc(n+1);
        n = fread(ui->data, 1, n, fp);
        ((char *)ui->data)[n] = '\0';
	sprintf(b, "Content-Length: %d\r\nContent-Type: %s\r\n",
		n, "text/html");
	ui->header = MwStrdup(b);
printf("header = '%s'\n", ui->header);
printf("strlen(data) = %d\n", strlen(ui->data));
	return 0;
}

